/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using SeriousSIP.Client;
using SeriousSIP.Model;

namespace SeriousSIP.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IContactsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1ContactsApiV1ContactsGet ();

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1ContactsApiV1ContactsGetWithHttpInfo ();
        /// <summary>
        /// Delete a contact from the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1ContactsContactDelete (string id = null);

        /// <summary>
        /// Delete a contact from the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1ContactsContactDeleteWithHttpInfo (string id = null);
        /// <summary>
        /// Create a new contact in the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1ContactsContactPost (NewContactParams body = null);

        /// <summary>
        /// Create a new contact in the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1ContactsContactPostWithHttpInfo (NewContactParams body = null);
        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1ContactsSubscribePost (ContactsSubscribeParams body = null);

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1ContactsSubscribePostWithHttpInfo (ContactsSubscribeParams body = null);
        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1ContactsUnsubscribePut (ContactsUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1ContactsUnsubscribePutWithHttpInfo (ContactsUnsubscribeParams body = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsApiV1ContactsGetAsync ();

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsApiV1ContactsGetAsyncWithHttpInfo ();
        /// <summary>
        /// Delete a contact from the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsContactDeleteAsync (string id = null);

        /// <summary>
        /// Delete a contact from the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsContactDeleteAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Create a new contact in the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsContactPostAsync (NewContactParams body = null);

        /// <summary>
        /// Create a new contact in the contact server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsContactPostAsyncWithHttpInfo (NewContactParams body = null);
        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsSubscribePostAsync (ContactsSubscribeParams body = null);

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsSubscribePostAsyncWithHttpInfo (ContactsSubscribeParams body = null);
        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsUnsubscribePutAsync (ContactsUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsUnsubscribePutAsyncWithHttpInfo (ContactsUnsubscribeParams body = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class ContactsApi : IContactsApi
    {
        private SeriousSIP.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ContactsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ContactsApi(String basePath)
        {
            this.Configuration = new SeriousSIP.Client.Configuration { BasePath = basePath };

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ContactsApi"/> class
        /// </summary>
        /// <returns></returns>
        public ContactsApi()
        {
            this.Configuration = SeriousSIP.Client.Configuration.Default;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ContactsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ContactsApi(SeriousSIP.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = SeriousSIP.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public SeriousSIP.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public SeriousSIP.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1ContactsApiV1ContactsGet ()
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1ContactsApiV1ContactsGetWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1ContactsApiV1ContactsGetWithHttpInfo ()
        {

            var localVarPath = "/api/v1/contacts/api/v1/contacts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsApiV1ContactsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsApiV1ContactsGetAsync ()
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1ContactsApiV1ContactsGetAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get all the contacts stored in the contact server with high level contact information. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsApiV1ContactsGetAsyncWithHttpInfo ()
        {

            var localVarPath = "/api/v1/contacts/api/v1/contacts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsApiV1ContactsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Delete a contact from the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1ContactsContactDelete (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1ContactsContactDeleteWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete a contact from the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1ContactsContactDeleteWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/contacts/contact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsContactDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Delete a contact from the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsContactDeleteAsync (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1ContactsContactDeleteAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete a contact from the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique id of the contact to be deleted. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsContactDeleteAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/contacts/contact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsContactDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Create a new contact in the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1ContactsContactPost (NewContactParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1ContactsContactPostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new contact in the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1ContactsContactPostWithHttpInfo (NewContactParams body = null)
        {

            var localVarPath = "/api/v1/contacts/contact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsContactPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Create a new contact in the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsContactPostAsync (NewContactParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1ContactsContactPostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new contact in the contact server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the NewContactParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsContactPostAsyncWithHttpInfo (NewContactParams body = null)
        {

            var localVarPath = "/api/v1/contacts/contact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsContactPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1ContactsSubscribePost (ContactsSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1ContactsSubscribePostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1ContactsSubscribePostWithHttpInfo (ContactsSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/contacts/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsSubscribePostAsync (ContactsSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1ContactsSubscribePostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Subscribe to contact server events to recieve webhook notifications on your contacts statuses. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsSubscribePostAsyncWithHttpInfo (ContactsSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/contacts/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1ContactsUnsubscribePut (ContactsUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1ContactsUnsubscribePutWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1ContactsUnsubscribePutWithHttpInfo (ContactsUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/contacts/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1ContactsUnsubscribePutAsync (ContactsUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1ContactsUnsubscribePutAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the ContactsUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1ContactsUnsubscribePutAsyncWithHttpInfo (ContactsUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/contacts/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1ContactsUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

    }
}
